## cpprest 2.10.15

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(cpprestsdk-root NONE)
enable_testing()
add_subdirectory(Release)

=== Build_iOS/CMakeLists.txt ===
project(casablanca-ios NONE)
cmake_minimum_required(VERSION 3.1)

enable_testing()

set(LIB_CPPREST libcpprest.a)
set(LIB_CPPREST_LIB_DIR "${CMAKE_CURRENT_BINARY_DIR}/lib")

if (CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET)
  set (ENV{CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET} ${CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET})
endif()

set(TOOLCHAIN_FILE "${CMAKE_CURRENT_SOURCE_DIR}/ios-cmake/ios.toolchain.cmake")

set(SIM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/build.i386" CACHE INTERNAL "")
set(SIM_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../Release" CACHE INTERNAL "")

set(SIM64_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/build.x86_64" CACHE INTERNAL "")
set(SIM64_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../Release" CACHE INTERNAL "")

set(ARM_BINARY_DIR "${CMAKE_CURRENT_BINARY_DIR}/build.arm" CACHE INTERNAL "")
set(ARM_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../Release" CACHE INTERNAL "")

if (DISABLE_BITCODE)
  set (ENABLE_BITCODE_ARG -DENABLE_BITCODE=OFF)
endif()

if (INCLUDE_32BIT)
  set (IOS_PLATFORM_VALUE OS)
else()
  set (IOS_PLATFORM_VALUE OS64)
endif()

if (DEPLOYMENT_TARGET)
  set (DEPLOYMENT_TARGET -DIOS_DEPLOYMENT_TARGET=${DEPLOYMENT_TARGET})
endif()

add_test(NAME ios_runner
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../Release/tests/common/testrunner/ios
    COMMAND xcodebuild test -project ios_runner.xcodeproj -configuration=${CMAKE_BUILD_TYPE} -scheme ios_runner -destination "platform=iOS Simulator,name=iPhone 6" LIBRARY_SEARCH_PATH=${SIM64_BINARY_DIR}
  )

if (INCLUDE_32BIT)
set (SIM_BINARY_LIB ${SIM_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST})
file(MAKE_DIRECTORY ${SIM_BINARY_DIR})
execute_process(WORKING_DIRECTORY ${SIM_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND}
    -GXcode
    -DCMAKE_TOOLCHAIN_FILE=${TOOLCHAIN_FILE}
    -DIOS_PLATFORM=SIMULATOR
    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
    "${DEPLOYMENT_TARGET}"
    "${SIM_SOURCE_DIR}"
)
else()
set (SIM_BINARY_LIB "")
endif()

file(MAKE_DIRECTORY ${SIM64_BINARY_DIR})
execute_process(WORKING_DIRECTORY ${SIM64_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND}
    -GXcode
    -DCMAKE_TOOLCHAIN_FILE=${TOOLCHAIN_FILE}
    -DIOS_PLATFORM=SIMULATOR64
    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
    "${DEPLOYMENT_TARGET}"
    "${SIM64_SOURCE_DIR}"
)

file(MAKE_DIRECTORY ${ARM_BINARY_DIR})
execute_process(WORKING_DIRECTORY ${ARM_BINARY_DIR}
  COMMAND ${CMAKE_COMMAND}
    -GXcode
    -DCMAKE_TOOLCHAIN_FILE=${TOOLCHAIN_FILE}
    -DIOS_PLATFORM=${IOS_PLATFORM_VALUE}
    -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
    "${DEPLOYMENT_TARGET}"
    "${ENABLE_BITCODE_ARG}"    
    "${ARM_SOURCE_DIR}"
    )

if (INCLUDE_32BIT)
set (SIM_TARGET sim)
## Simulator i386 version
add_custom_target(sim
  COMMAND ${CMAKE_COMMAND}
    --build ${SIM_BINARY_DIR}
    --config ${CMAKE_BUILD_TYPE}
    COMMENT "Building for i386 (simulator)"
VERBATIM
)
else()
set (SIM_TARGET "")
endif()

## Simulator x86_64 version
add_custom_target(sim64
  COMMAND ${CMAKE_COMMAND}
    --build ${SIM64_BINARY_DIR}
    --config ${CMAKE_BUILD_TYPE}
    COMMENT "Building for x86_64 (simulator)"
VERBATIM
)

## ARM version
add_custom_target(arm
  COMMAND ${CMAKE_COMMAND}
    --build ${ARM_BINARY_DIR}
    --config ${CMAKE_BUILD_TYPE}
  COMMENT "Building for arm"
  VERBATIM
)

add_custom_command(
  OUTPUT ${LIB_CPPREST_LIB_DIR}/${LIB_CPPREST}
  COMMAND mkdir -p "${LIB_CPPREST_LIB_DIR}"
  COMMAND lipo -create
    -output "${LIB_CPPREST_LIB_DIR}/${LIB_CPPREST}"
    ${SIM_BINARY_LIB}
    ${SIM64_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}
    ${ARM_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}
  COMMAND cp -R "${CMAKE_CURRENT_SOURCE_DIR}/../Release/include" "${CMAKE_CURRENT_BINARY_DIR}"
  DEPENDS
    ${SIM_TARGET}
    sim64
    arm
    ${SIM_BINARY_LIB}
    "${SIM64_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}"
    "${ARM_BINARY_DIR}/Binaries/${CMAKE_BUILD_TYPE}/${LIB_CPPREST}"
  VERBATIM
)

add_custom_target(cpprest ALL DEPENDS "${LIB_CPPREST_LIB_DIR}/${LIB_CPPREST}")

=== Release/CMakeLists.txt ===
set(CMAKE_LEGACY_CYGWIN_WIN32 0)
cmake_minimum_required(VERSION 3.1)
if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # use MACOSX_RPATH
endif()
if(UNIX)
  project(cpprestsdk C CXX)
else()
  project(cpprestsdk CXX)
endif()

set(CPPREST_VERSION_MAJOR 2)
set(CPPREST_VERSION_MINOR 10)
set(CPPREST_VERSION_REVISION 15)

enable_testing()

set(WERROR ON CACHE BOOL "Treat Warnings as Errors.")
set(CPPREST_EXCLUDE_WEBSOCKETS OFF CACHE BOOL "Exclude websockets functionality.")
set(CPPREST_EXCLUDE_COMPRESSION OFF CACHE BOOL "Exclude compression functionality.")
set(CPPREST_EXCLUDE_BROTLI ON CACHE BOOL "Exclude Brotli compression functionality.")
set(CPPREST_EXPORT_DIR cmake/cpprestsdk CACHE STRING "Directory to install CMake config files.")
set(CPPREST_INSTALL_HEADERS ON CACHE BOOL "Install header files.")
set(CPPREST_INSTALL ON CACHE BOOL "Add install commands.")

if(IOS OR ANDROID)
  set(BUILD_SHARED_LIBS OFF CACHE BOOL "Build shared libraries")
else()
  set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")
endif()

if(IOS OR ANDROID OR WINDOWS_STORE OR WINDOWS_PHONE)
  set(BUILD_TESTS OFF CACHE BOOL "Build tests.")
  set(BUILD_SAMPLES OFF CACHE BOOL "Build sample applications.")
else()
  set(BUILD_TESTS ON CACHE BOOL "Build tests.")
  set(BUILD_SAMPLES ON CACHE BOOL "Build sample applications.")
endif()

if(WIN32)
  set(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "Default filename postfix for libraries under configuration DEBUG")
else()
  set(CMAKE_DEBUG_POSTFIX "" CACHE STRING "Default filename postfix for libraries under configuration DEBUG")
endif()

if(WIN32)
  set(TOOLSET)
  if(CMAKE_VS_PLATFORM_TOOLSET)
    string(REGEX REPLACE "^v" "" TOOLSET "${CMAKE_VS_PLATFORM_TOOLSET}")
  endif()
  set(CPPREST_ABI_TAG "${TOOLSET}_${CPPREST_VERSION_MAJOR}_${CPPREST_VERSION_MINOR}" CACHE STRING "Postfix tag for the cpprest abi")
else()
  set(CPPREST_ABI_TAG "" CACHE STRING "Postfix tag for the cpprest abi")
endif()

if(ANDROID)
  set(Boost_USE_STATIC_LIBS ON CACHE BOOL "Link against boost statically.")
else()
  set(Boost_USE_STATIC_LIBS OFF CACHE BOOL "Link against boost statically.")
endif()

include(cmake/cpprest_find_boost.cmake)
include(cmake/cpprest_find_zlib.cmake)
include(cmake/cpprest_find_winhttppal.cmake)
include(cmake/cpprest_find_openssl.cmake)
include(cmake/cpprest_find_websocketpp.cmake)
include(cmake/cpprest_find_brotli.cmake)
include(CheckIncludeFiles)
include(GNUInstallDirs)

find_package(Threads REQUIRED)
if(THREADS_HAVE_PTHREAD_ARG)
  add_compile_options(-pthread)
endif()
if(CMAKE_THREAD_LIBS_INIT)
  link_libraries(${CMAKE_THREAD_LIBS_INIT})
endif()

# Internal component selection logic. This allows us to avoid duplicating platform logic in multiple places.
if(CPPREST_EXCLUDE_WEBSOCKETS)
  set(CPPREST_WEBSOCKETS_IMPL none CACHE STRING "Internal use.")
endif()

if(NOT WIN32)
  CHECK_INCLUDE_FILES(xlocale.h HAVE_XLOCALE_H)
endif()

if(APPLE) # Note: also iOS
  set(CPPREST_PPLX_IMPL apple CACHE STRING "Internal use.")
  set(CPPREST_WEBSOCKETS_IMPL wspp CACHE STRING "Internal use.")
  set(CPPREST_FILEIO_IMPL posix CACHE STRING "Internal use.")
  set(CPPREST_HTTP_CLIENT_IMPL asio CACHE STRING "Internal use.")
  set(CPPREST_HTTP_LISTENER_IMPL asio CACHE STRING "Internal use.")
elseif(UNIX AND NOT APPLE) # Note: also android
  set(CPPREST_PPLX_IMPL linux CACHE STRING "Internal use.")
  set(CPPREST_WEBSOCKETS_IMPL wspp CACHE STRING "Internal use.")
  set(CPPREST_FILEIO_IMPL posix CACHE STRING "Internal use.")
  set(CPPREST_HTTP_CLIENT_IMPL asio CACHE STRING "Internal use.")
  set(CPPREST_HTTP_LISTENER_IMPL asio CACHE STRING "Internal use.")
elseif(WINDOWS_PHONE OR WINDOWS_STORE)
  set(CPPREST_PPLX_IMPL winrt CACHE STRING "Internal use.")
  set(CPPREST_WEBSOCKETS_IMPL winrt CACHE STRING "Internal use.")
  set(CPPREST_FILEIO_IMPL winrt CACHE STRING "Internal use.")
  set(CPPREST_HTTP_CLIENT_IMPL winrt CACHE STRING "Internal use.")
  set(CPPREST_HTTP_LISTENER_IMPL none CACHE STRING "Internal use.")
elseif(WIN32)
  set(CPPREST_PPLX_IMPL win CACHE STRING "Internal use.")
  set(CPPREST_WEBSOCKETS_IMPL wspp CACHE STRING "Internal use.")
  set(CPPREST_FILEIO_IMPL win32 CACHE STRING "Internal use.")
  set(CPPREST_HTTP_CLIENT_IMPL winhttp CACHE STRING "Internal use.")
  set(CPPREST_HTTP_LISTENER_IMPL httpsys CACHE STRING "Internal use.")
else()
  message(FATAL_ERROR "Unknown platform. Cannot determine appropriate feature implementations.")
endif()

set(WARNINGS)
set(ANDROID_LIBS)

# Platform (not compiler) specific settings
if(ANDROID)
  # These are used in the shared library case
  set(ANDROID_LIBS atomic dl)
elseif(UNIX) # This includes OSX
elseif(WIN32)
  add_definitions(-DUNICODE -D_UNICODE -DWIN32 -D_SCL_SECURE_NO_WARNINGS)
  if(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
    add_definitions(-D_WIN32_WINNT=0x0A00)
  else()
    add_definitions(-D_WIN32_WINNT=0x0600)
  endif()

  if(NOT BUILD_SHARED_LIBS)
    # This causes cmake to not link the test libraries separately, but instead hold onto their object files.
    set(TEST_LIBRARY_TARGET_TYPE OBJECT)
  endif()

  add_definitions(-D_WINSOCK_DEPRECATED_NO_WARNINGS)
else()
  message(FATAL_ERROR "-- Unsupported Build Platform.")
endif()

# Compiler (not platform) specific settings
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR IOS)
  message("-- Setting clang options")

  if(ANDROID)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-pedantic -Wno-attributes -Wno-pointer-arith")
  elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(WARNINGS -Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Winit-self -Winvalid-pch -Wmissing-format-attribute -Wmissing-include-dirs -Wpacked -Wredundant-decls)
    set(LINUX_SUPPRESSIONS -Wno-overloaded-virtual -Wno-sign-conversion -Wno-deprecated -Wno-unknown-pragmas -Wno-reorder -Wno-char-subscripts -Wno-switch -Wno-unused-parameter -Wno-unused-variable -Wno-deprecated -Wno-unused-value -Wno-unknown-warning-option -Wno-return-type-c-linkage -Wno-unused-function -Wno-sign-compare -Wno-shorten-64-to-32 -Wno-unused-local-typedefs)
    set(WARNINGS ${WARNINGS} ${LINUX_SUPPRESSIONS})
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-return-type-c-linkage -Wno-unneeded-internal-declaration")
  else()
    set(WARNINGS -Wall -Wextra -Wcast-qual -Wconversion -Wformat=2 -Winit-self -Winvalid-pch -Wmissing-format-attribute -Wmissing-include-dirs -Wpacked -Wredundant-decls)
    set(OSX_SUPPRESSIONS -Wno-overloaded-virtual -Wno-sign-conversion -Wno-deprecated -Wno-unknown-pragmas -Wno-reorder -Wno-char-subscripts -Wno-switch -Wno-unused-parameter -Wno-unused-variable -Wno-deprecated -Wno-unused-value -Wno-unknown-warning-option -Wno-return-type-c-linkage -Wno-unused-function -Wno-sign-compare -Wno-shorten-64-to-32 -Wno-unused-local-typedefs)
    set(WARNINGS ${WARNINGS} ${OSX_SUPPRESSIONS})

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++ -Wno-return-type-c-linkage -Wno-unneeded-internal-declaration")
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LIBRARY "libc++")
    set(CMAKE_XCODE_ATTRIBUTE_CLANG_CXX_LANGUAGE_STANDARD "c++11")
  endif()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")

elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  message("-- Setting gcc options")

  set(WARNINGS -Wall -Wextra -Wunused-parameter -Wcast-align -Wcast-qual -Wconversion -Wformat=2 -Winit-self -Winvalid-pch -Wmissing-format-attribute -Wmissing-include-dirs -Wpacked -Wredundant-decls -Wunreachable-code)
  set(LD_FLAGS "${LD_FLAGS} -Wl,-z,defs")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -fno-strict-aliasing")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.8)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive -D_GLIBCXX_USE_SCHED_YIELD -D_GLIBCXX_USE_NANOSLEEP")
  endif()

elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  message("-- Setting msvc options")
  set(WARNINGS)
  set(CMAKE_STATIC_LINKER_FLAGS "${CMAKE_STATIC_LINKER_FLAGS} /ignore:4264")
  add_compile_options(/bigobj)
  set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MP")
  set(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /MP")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MP")
  set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO} /MP")

  set(CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL "${CMAKE_SHARED_LINKER_FLAGS_MINSIZEREL} /profile /OPT:REF /OPT:ICF")
  set(CMAKE_SHARED_LINKER_FLAGS_RELEASE "${CMAKE_SHARED_LINKER_FLAGS_RELEASE} /profile /OPT:REF /OPT:ICF")

  if (WINDOWS_STORE OR WINDOWS_PHONE)
    add_compile_options(/ZW)
  else()
    if (NOT (MSVC_VERSION LESS 1920))
      add_compile_options(/permissive-)
    endif()
  endif()
else()
  message("-- Unknown compiler, success is doubtful.")
  message("CMAKE_CXX_COMPILER_ID=${CMAKE_CXX_COMPILER_ID}")
endif()

# Reconfigure final output directory
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/Binaries)

function(configure_pch target precompile_header precomile_source) # optional additional compile arguments
  if(MSVC)
    get_target_property(_srcs ${target} SOURCES)

    set(pch_output_filepath_arg)
    if(NOT CMAKE_GENERATOR MATCHES "Visual Studio .*")
      set_property(SOURCE ${precomile_source} APPEND PROPERTY OBJECT_OUTPUTS "${CMAKE_CURRENT_BINARY_DIR}/${target}.pch")
      set_property(SOURCE ${_srcs} APPEND PROPERTY OBJECT_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${target}.pch")
      set(pch_output_filepath_arg "/Fp${CMAKE_CURRENT_BINARY_DIR}/${target}.pch")
    else()
      # Don't specify output file so that VS may choose a config spefic location.
	  # Otherwise Debug/Release builds will interfere with one another.
    endif()

    set_source_files_properties(${precomile_source} PROPERTIES COMPILE_FLAGS "/Yc${precompile_header}")
    target_sources(${target} PRIVATE ${precomile_source})
	# Note: as ${precomile_source} is also a SOURCE for ${target}, the below options will also be applied.
	# ${precomile_source} has /Yc option that will cause the shared /Yu to be ignored.
    target_compile_options(${target} PRIVATE /Yu${precompile_header} ${pch_output_filepath_arg} ${ARGN})
  endif()
endfunction()

# These settings can be used by the test targets
set(Casablanca_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(Casablanca_LIBRARY cpprest)
set(Casablanca_LIBRARIES cpprest)
get_directory_property(PARENT_DIR PARENT_DIRECTORY)
if(NOT PARENT_DIR STREQUAL "")
  set(Casablanca_LIBRARIES ${Casablanca_LIBRARIES} PARENT_SCOPE)
endif()

# Finally, the tests all use the same style declaration to build themselves, so we use a function
function(add_casablanca_test NAME SOURCES_VAR)
  add_library(${NAME} ${TEST_LIBRARY_TARGET_TYPE} ${${SOURCES_VAR}})
  message("-- Added test library ${NAME}")
  if(TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
    foreach(_dep cpprest common_utilities unittestpp)
      target_include_directories(${NAME} PRIVATE $<TARGET_PROPERTY:${_dep},INTERFACE_INCLUDE_DIRECTORIES>)
      target_compile_definitions(${NAME} PRIVATE $<TARGET_PROPERTY:${_dep},INTERFACE_COMPILE_DEFINITIONS>)
    endforeach()
  else()
    target_link_libraries(${NAME} PRIVATE
      cpprest
      common_utilities
      unittestpp
      ${ANDROID_LIBS}
    )
    if (BUILD_SHARED_LIBS)
      add_test(NAME ${NAME}
        WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
        COMMAND test_runner $<TARGET_FILE_NAME:${NAME}>
      )
    endif()
  endif()
endfunction()

add_subdirectory(src)

if(BUILD_TESTS)
  add_subdirectory(tests)
endif()

if(BUILD_SAMPLES)
  add_subdirectory(samples)
endif()

=== Release/src/CMakeLists.txt ===
cmake_policy(SET CMP0022 NEW)

file(GLOB HEADERS_CPPREST "../include/cpprest/*.h" "../include/cpprest/*.hpp" "../include/cpprest/*.dat")
file(GLOB HEADERS_PPLX "../include/pplx/*.h" "../include/pplx/*.hpp")
file(GLOB HEADERS_DETAILS "../include/cpprest/details/*.h" "../include/cpprest/details/*.hpp" "../include/cpprest/details/*.dat" "../include/pplx/*.hpp" "../include/pplx/*.dat")
source_group("Header Files\\cpprest" FILES ${HEADERS_CPPREST})
source_group("Header Files\\pplx" FILES ${HEADERS_PPLX})
source_group("Header Files\\cpprest\\details" FILES ${HEADERS_DETAILS})

file(GLOB HEADER_PPLX_THREADPOOL "../include/pplx/threadpool.h")
list(REMOVE_ITEM HEADERS_PPLX ${HEADER_PPLX_THREADPOOL})

set(SOURCES
  ${HEADERS_CPPREST}
  ${HEADERS_PPLX}
  ${HEADERS_DETAILS}
  pch/stdafx.h
  http/client/http_client.cpp
  http/client/http_client_impl.h
  http/client/http_client_msg.cpp
  http/common/connection_pool_helpers.h
  http/common/http_compression.cpp
  http/common/http_helpers.cpp
  http/common/http_msg.cpp
  http/common/internal_http_helpers.h
  http/listener/http_listener.cpp
  http/listener/http_listener_msg.cpp
  http/listener/http_server_api.cpp
  http/listener/http_server_impl.h
  http/oauth/oauth1.cpp
  http/oauth/oauth2.cpp
  json/json.cpp
  json/json_parsing.cpp
  json/json_serialization.cpp
  uri/uri.cpp
  uri/uri_builder.cpp
  utilities/asyncrt_utils.cpp
  utilities/base64.cpp
  utilities/web_utilities.cpp
)

add_library(cpprest ${SOURCES})
target_include_directories(cpprest
  PUBLIC
    $<INSTALL_INTERFACE:include> $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  PRIVATE
    pch
)

## Sub-components
# Websockets component
if(CPPREST_WEBSOCKETS_IMPL STREQUAL "none")
  target_compile_definitions(cpprest PUBLIC -DCPPREST_EXCLUDE_WEBSOCKETS=1)
elseif(CPPREST_WEBSOCKETS_IMPL STREQUAL "winrt")
  target_sources(cpprest PRIVATE
    websockets/client/ws_msg.cpp
    websockets/client/ws_client.cpp
    websockets/client/ws_client_impl.h
    websockets/client/ws_client_winrt.cpp
  )
elseif(CPPREST_WEBSOCKETS_IMPL STREQUAL "wspp")
  target_sources(cpprest PRIVATE
    websockets/client/ws_msg.cpp
    websockets/client/ws_client.cpp
    websockets/client/ws_client_impl.h
    websockets/client/ws_client_wspp.cpp
  )
  cpprest_find_websocketpp()
  target_link_libraries(cpprest PRIVATE cpprestsdk_websocketpp_internal)
  cpprest_find_boost()
  cpprest_find_openssl()
  target_link_libraries(cpprest PUBLIC cpprestsdk_boost_internal cpprestsdk_openssl_internal)
else()
  message(FATAL_ERROR "Invalid implementation")
endif()

# Compression component
if(CPPREST_EXCLUDE_COMPRESSION)
  if(NOT CPPREST_EXCLUDE_BROTLI)
    message(FATAL_ERROR "Use of Brotli requires compression to be enabled")
  endif()
  target_compile_definitions(cpprest PRIVATE -DCPPREST_EXCLUDE_COMPRESSION=1)
else()
  cpprest_find_zlib()
  target_link_libraries(cpprest PRIVATE cpprestsdk_zlib_internal)
  if(CPPREST_EXCLUDE_BROTLI)
    target_compile_definitions(cpprest PRIVATE -DCPPREST_EXCLUDE_BROTLI=1)
  else()
    cpprest_find_brotli()
  endif()
endif()

# PPLX component
if(CPPREST_PPLX_IMPL STREQUAL "apple")
  find_library(COREFOUNDATION CoreFoundation "/")
  find_library(SECURITY Security "/")
  target_link_libraries(cpprest PUBLIC ${COREFOUNDATION} ${SECURITY})
  target_sources(cpprest PRIVATE pplx/pplxapple.cpp pplx/pplx.cpp pplx/threadpool.cpp ../include/pplx/threadpool.h)
  if(CPPREST_INSTALL_HEADERS)
    install(FILES ../include/pplx/threadpool.h DESTINATION include/pplx)
  endif()
elseif(CPPREST_PPLX_IMPL STREQUAL "linux")
  target_sources(cpprest PRIVATE pplx/pplxlinux.cpp pplx/pplx.cpp pplx/threadpool.cpp ../include/pplx/threadpool.h)
  if(CPPREST_INSTALL_HEADERS)
    install(FILES ../include/pplx/threadpool.h DESTINATION include/pplx)
  endif()
elseif(CPPREST_PPLX_IMPL STREQUAL "win")
  target_sources(cpprest PRIVATE pplx/pplxwin.cpp)
  if(CPPREST_WEBSOCKETS_IMPL STREQUAL "wspp")
    target_sources(cpprest PRIVATE pplx/threadpool.cpp ../include/pplx/threadpool.h)
    if(CPPREST_INSTALL_HEADERS)
      install(FILES ../include/pplx/threadpool.h DESTINATION include/pplx)
    endif()
  endif()
elseif(CPPREST_PPLX_IMPL STREQUAL "winpplx")
  target_compile_definitions(cpprest PUBLIC -DCPPREST_FORCE_PPLX=1)
  target_sources(cpprest PRIVATE pplx/pplxwin.cpp pplx/pplx.cpp pplx/threadpool.cpp ../include/pplx/threadpool.h)
  if(CPPREST_INSTALL_HEADERS)
    install(FILES ../include/pplx/threadpool.h DESTINATION include/pplx)
  endif()
elseif(CPPREST_PPLX_IMPL STREQUAL "winrt")
  target_sources(cpprest PRIVATE pplx/pplxwin.cpp)
else()
  message(FATAL_ERROR "Invalid implementation")
endif()

# Http client component
if(CPPREST_HTTP_CLIENT_IMPL STREQUAL "asio")
  cpprest_find_boost()
  cpprest_find_openssl()
  target_compile_definitions(cpprest PUBLIC -DCPPREST_FORCE_HTTP_CLIENT_ASIO)
  target_sources(cpprest PRIVATE http/client/http_client_asio.cpp http/client/x509_cert_utilities.cpp)
  target_link_libraries(cpprest PUBLIC cpprestsdk_boost_internal cpprestsdk_openssl_internal)
elseif(CPPREST_HTTP_CLIENT_IMPL STREQUAL "winhttppal")
  cpprest_find_boost()
  cpprest_find_openssl()
  cpprest_find_winhttppal()
  target_compile_definitions(cpprest PUBLIC -DCPPREST_FORCE_HTTP_CLIENT_WINHTTPPAL)
  target_sources(cpprest PRIVATE http/client/http_client_winhttp.cpp http/client/x509_cert_utilities.cpp)
  target_link_libraries(cpprest PUBLIC cpprestsdk_boost_internal cpprestsdk_openssl_internal cpprestsdk_winhttppal_internal)
elseif(CPPREST_HTTP_CLIENT_IMPL STREQUAL "winhttp")
  target_link_libraries(cpprest PRIVATE
    Winhttp.lib
  )
  target_sources(cpprest PRIVATE http/client/http_client_winhttp.cpp)
  if(CPPREST_WEBSOCKETS_IMPL STREQUAL "wspp")
    target_sources(cpprest PRIVATE http/client/x509_cert_utilities.cpp)
  endif()
elseif(CPPREST_HTTP_CLIENT_IMPL STREQUAL "winrt")
  target_sources(cpprest PRIVATE http/client/http_client_winrt.cpp)
else()
  message(FATAL_ERROR "Invalid implementation")
endif()

# fileio streams component
if(CPPREST_FILEIO_IMPL STREQUAL "win32")
  target_sources(cpprest PRIVATE streams/fileio_win32.cpp)
elseif(CPPREST_FILEIO_IMPL STREQUAL "winrt")
  target_sources(cpprest PRIVATE streams/fileio_winrt.cpp)
elseif(CPPREST_FILEIO_IMPL STREQUAL "posix")
  target_sources(cpprest PRIVATE streams/fileio_posix.cpp)
else()
  message(FATAL_ERROR "Invalid implementation")
endif()

# http listener component
if(CPPREST_HTTP_LISTENER_IMPL STREQUAL "asio")
  cpprest_find_boost()
  cpprest_find_openssl()
  target_compile_definitions(cpprest PUBLIC -DCPPREST_FORCE_HTTP_LISTENER_ASIO)
  target_sources(cpprest PRIVATE http/listener/http_server_asio.cpp)
  target_link_libraries(cpprest PUBLIC cpprestsdk_boost_internal cpprestsdk_openssl_internal)
elseif(CPPREST_HTTP_LISTENER_IMPL STREQUAL "httpsys")
  target_sources(cpprest PRIVATE
    http/listener/http_server_httpsys.cpp
    http/listener/http_server_httpsys.h
  )
  target_link_libraries(cpprest PRIVATE
    httpapi.lib
  )
elseif(CPPREST_HTTP_LISTENER_IMPL STREQUAL "none")
else()
  message(FATAL_ERROR "Invalid implementation")
endif()

configure_pch(cpprest stdafx.h pch/stdafx.cpp /Zm120)

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  if(WERROR)
    target_compile_options(cpprest PRIVATE -Werror)
  endif()
  target_compile_options(cpprest PRIVATE -pedantic ${WARNINGS})
elseif(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
  if(WERROR)
    target_compile_options(cpprest PRIVATE /WX ${WARNINGS})
  endif()
else()
  message(FATAL_ERROR "Unknown compiler")
endif()

if(WIN32)
  if (BUILD_SHARED_LIBS)
    target_compile_definitions(cpprest PRIVATE -D_ASYNCRT_EXPORT -D_PPLX_EXPORT -D_USRDLL)
  else()
    target_compile_definitions(cpprest PUBLIC -D_NO_ASYNCRTIMP -D_NO_PPLXIMP)
  endif()
elseif(ANDROID)
  target_link_libraries(cpprest PRIVATE ${ANDROID_STL_FLAGS})
endif()

if (WIN32 AND NOT WINDOWS_STORE AND NOT WINDOWS_PHONE)
  target_link_libraries(cpprest PRIVATE
    bcrypt.lib
    crypt32.lib
  )
elseif(WINDOWS_STORE)
  if(NOT CMAKE_GENERATOR MATCHES "Visual Studio .*")
    target_compile_definitions(cpprest PRIVATE -DWINAPI_FAMILY=WINAPI_FAMILY_PC_APP)
    get_target_property(LINK_FLAGS cpprest LINK_FLAGS)
    if(NOT LINK_FLAGS)
        set(LINK_FLAGS "")
    endif()
    set(LINK_FLAGS "${LINK_FLAGS} /APPCONTAINER")
    set_target_properties(cpprest PROPERTIES LINK_FLAGS "${LINK_FLAGS}")
  endif()
endif()

set_target_properties(cpprest PROPERTIES OUTPUT_NAME "cpprest${CPPREST_ABI_TAG}")
if(WIN32)
elseif(ANDROID)
  # Do not use SOVERSION on android. It is completely unsupported (and causes problems).
  # Perhaps revisit in the future? (NDK r9d, 8/7/14)
else()
  set_target_properties(cpprest PROPERTIES
    SOVERSION ${CPPREST_VERSION_MAJOR}.${CPPREST_VERSION_MINOR})
endif()

if(CPPREST_INSTALL_HEADERS)
  install(FILES ${HEADERS_CPPREST} DESTINATION include/cpprest)
  install(FILES ${HEADERS_PPLX} DESTINATION include/pplx)
  install(FILES ${HEADERS_DETAILS} DESTINATION include/cpprest/details)
endif()

if(CPPREST_INSTALL)
  set(CPPREST_USES_BOOST OFF)
  set(CPPREST_USES_ZLIB OFF)
  set(CPPREST_USES_BROTLI OFF)
  set(CPPREST_USES_OPENSSL OFF)
  set(CPPREST_USES_WINHTTPPAL OFF)

  set(CPPREST_TARGETS cpprest)
  if(TARGET cpprestsdk_boost_internal)
    list(APPEND CPPREST_TARGETS cpprestsdk_boost_internal)
    set(CPPREST_USES_BOOST ON)
  endif()
  if(TARGET cpprestsdk_zlib_internal)
    list(APPEND CPPREST_TARGETS cpprestsdk_zlib_internal)
    set(CPPREST_USES_ZLIB ON)
  endif()
  if(TARGET cpprestsdk_brotli_internal)
    list(APPEND CPPREST_TARGETS cpprestsdk_brotli_internal)
    set(CPPREST_USES_BROTLI ON)
  endif()
  if(TARGET cpprestsdk_openssl_internal)
    list(APPEND CPPREST_TARGETS cpprestsdk_openssl_internal)
    set(CPPREST_USES_OPENSSL ON)
  endif()
  if(TARGET cpprestsdk_winhttppal_internal)
    list(APPEND CPPREST_TARGETS cpprestsdk_winhttppal_internal)
    set(CPPREST_USES_WINHTTPPAL ON)
  endif()
  if(TARGET cpprestsdk_websocketpp_internal)
    list(APPEND CPPREST_TARGETS cpprestsdk_websocketpp_internal)
  endif()
  install(
    TARGETS ${CPPREST_TARGETS}
    EXPORT cpprestsdk-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

  configure_file(../cmake/cpprestsdk-config.in.cmake "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake" @ONLY)

  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/${CPPREST_EXPORT_DIR}
  )
  install(
    EXPORT cpprestsdk-targets
    FILE cpprestsdk-targets.cmake
    NAMESPACE cpprestsdk::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/${CPPREST_EXPORT_DIR}
  )
endif()

=== Release/samples/BingRequest/CMakeLists.txt ===
if (NOT WINDOWS_STORE AND NOT WINDOWS_PHONE)
  add_executable(BingRequest bingrequest.cpp)
  target_link_libraries(BingRequest cpprest)
endif()

=== Release/samples/SearchFile/CMakeLists.txt ===
if (NOT WINDOWS_STORE AND NOT WINDOWS_PHONE)
  add_executable(SearchFile searchfile.cpp)
  target_link_libraries(SearchFile cpprest)
endif()

=== Release/tests/common/CMakeLists.txt ===
add_subdirectory(utilities)
add_subdirectory(UnitTestpp)
add_subdirectory(TestRunner)

=== Release/tests/functional/CMakeLists.txt ===
add_subdirectory(http)
add_subdirectory(json)
add_subdirectory(pplx)
add_subdirectory(streams)
add_subdirectory(uri)
add_subdirectory(utils)
add_subdirectory(websockets)

=== Release/tests/common/TestRunner/CMakeLists.txt ===
if (WIN32)
  if (WINDOWS_STORE OR WINDOWS_PHONE)
    add_definitions(-DWINRT_TEST_RUNNER -D_CONSOLE)
  else()
    add_definitions(-DDESKTOP_TEST_RUNNER)
  endif()
endif()

add_executable(test_runner test_runner.cpp test_module_loader.cpp)
target_link_libraries(test_runner PRIVATE unittestpp ${CMAKE_DL_LIBS})

if(BUILD_SHARED_LIBS AND NOT TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
elseif(APPLE)
  target_link_libraries(test_runner PRIVATE
    -Wl,-force_load httpclient_test
    -Wl,-force_load json_test
    -Wl,-force_load uri_test
    -Wl,-force_load pplx_test
    -Wl,-force_load httplistener_test
    -Wl,-force_load streams_test
    -Wl,-force_load utils_test
    )
elseif(UNIX)
  target_link_libraries(test_runner PRIVATE
    -Wl,--whole-archive
    httpclient_test
    json_test
    uri_test
    pplx_test
    httplistener_test
    streams_test
    utils_test
    -Wl,--no-whole-archive
    )
else()
  # In order to achieve --whole-archive on windows, we link all the test files into the test_runner directly
  # This means that the tests themselves must be created as "OBJECT" libraries
  target_sources(test_runner PRIVATE
    $<TARGET_OBJECTS:httpclient_test>
    $<TARGET_OBJECTS:json_test>
    $<TARGET_OBJECTS:uri_test>
    $<TARGET_OBJECTS:pplx_test>
    $<TARGET_OBJECTS:streams_test>
    $<TARGET_OBJECTS:utils_test>
  )
  if(NOT WINDOWS_STORE AND NOT WINDOWS_PHONE)
    target_sources(test_runner PRIVATE $<TARGET_OBJECTS:httplistener_test>)
  endif()
  target_link_libraries(test_runner PRIVATE
    common_utilities
    httptest_utilities
    cpprest
  )
  if(TARGET websockettest_utilities)
      target_link_libraries(test_runner PRIVATE websockettest_utilities)
  endif()
  if(CPPREST_WEBSOCKETS_IMPL STREQUAL "wspp")
    cpprest_find_websocketpp()
    target_link_libraries(test_runner PRIVATE cpprestsdk_websocketpp_internal)
  endif()
  if (WINDOWS_STORE)
    target_link_libraries(test_runner PRIVATE ucrtd.lib vcruntimed.lib vccorlibd.lib msvcrtd.lib msvcprtd.lib concrtd.lib RuntimeObject.lib)
  endif()
endif()

=== Release/tests/common/UnitTestpp/CMakeLists.txt ===
set(UT_SOURCES
  src/AssertException.cpp
  src/CompositeTestReporter.cpp
  src/CurrentTest.cpp
  src/DeferredTestReporter.cpp
  src/DeferredTestResult.cpp
  src/GlobalSettings.cpp
  src/MemoryOutStream.cpp
  src/ReportAssert.cpp
  src/Test.cpp
  src/TestDetails.cpp
  src/TestList.cpp
  src/TestReporter.cpp
  src/TestReporterStdout.cpp
  src/TestResults.cpp
  src/TestRunner.cpp
  src/XmlTestReporter.cpp
  )

set(TEST_SOURCES
  src/tests/TestAssertHandler.cpp
  src/tests/TestCheckMacros.cpp
  src/tests/TestChecks.cpp
  src/tests/TestCompositeTestReporter.cpp
  src/tests/TestCurrentTest.cpp
  src/tests/TestDeferredTestReporter.cpp
  src/tests/TestMemoryOutStream.cpp
  src/tests/TestTest.cpp
  src/tests/TestTestList.cpp
  src/tests/TestTestMacros.cpp
  src/tests/TestTestResults.cpp
  src/tests/TestTestRunner.cpp
  src/tests/TestTestSuite.cpp
  src/tests/TestUnitTestPP.cpp
  src/tests/TestXmlTestReporter.cpp
  )

if(UNIX)
  list(APPEND UT_SOURCES
    src/Posix/SignalTranslator.cpp
    src/Posix/TimeHelpers.cpp
    )
elseif(WIN32)
  list(APPEND UT_SOURCES src/Win32/TimeHelpers.cpp)

  add_definitions(-DWIN32 -D_USRDLL -D_CRT_SECURE_NO_DEPRECATE -DUNITTEST_DLL_EXPORT)
endif()

add_library(unittestpp ${UT_SOURCES})
target_link_libraries(unittestpp PUBLIC cpprest)

if(UNIX)
  cpprest_find_boost()
  target_link_libraries(unittestpp PUBLIC cpprestsdk_boost_internal)
endif()
target_link_libraries(unittestpp ${ANDROID_STL_FLAGS})

target_include_directories(unittestpp PRIVATE src)
target_include_directories(unittestpp PUBLIC .)

=== Release/tests/functional/uri/CMakeLists.txt ===
set(SOURCES
  accessor_tests.cpp
  combining_tests.cpp
  constructor_tests.cpp
  conversions_tests.cpp
  diagnostic_tests.cpp
  encoding_tests.cpp
  operator_tests.cpp
  splitting_tests.cpp
  uri_builder_tests.cpp
  resolve_uri_tests.cpp
)

add_casablanca_test(uri_test SOURCES)

configure_pch(uri_test stdafx.h stdafx.cpp)

=== Release/tests/functional/utils/CMakeLists.txt ===
set(SOURCES
  datetime.cpp
  base64.cpp
  strings.cpp
  macro_test.cpp
  nonce_generator_tests.cpp
  win32_encryption_tests.cpp
)

add_casablanca_test(utils_test SOURCES)

if(CMAKE_COMPILER_IS_GNUCXX)
  target_compile_options(utils_test PRIVATE "-Wno-deprecated-declarations")
endif()

configure_pch(utils_test stdafx.h stdafx.cpp)

=== debian/changelog ===
cpprest (2.10.15-1) unstable; urgency=medium

  * New upstream version 2.10.15
  * Refresh patch
  * std-version, bump to 4.5.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Feb 2020 15:15:54 +0100

cpprest (2.10.14-3) unstable; urgency=medium

  * Fix cmake installation directory (LP: #1838826)
  * std-version, bump to 4.4.1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 09 Jan 2020 12:04:29 +0100

=== debian/control ===
Source: cpprest
Section: libs
Priority: optional
Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libbrotli-dev,
               libboost-atomic-dev,
               libboost-chrono-dev,
               libboost-filesystem-dev,
               libboost-random-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libssl-dev,
               libwebsocketpp-dev,
               pkg-config,
               zlib1g-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.5.0
Homepage: https://github.com/Microsoft/cpprestsdk
Vcs-Git: https://salsa.debian.org/debian/cpprest.git
Vcs-Browser: https://salsa.debian.org/debian/cpprest

Package: libcpprest2.10
Provides: libcpprest
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Shared library for C++ REST SDK / Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains the library files.

Package: libcpprest-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends: libcpprest2.10 (= ${binary:Version}),
         libbrotli-dev,
         libboost-atomic-dev,
         libboost-chrono-dev,
         libboost-filesystem-dev,
         libboost-random-dev,
         libboost-regex-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libssl-dev,
         libwebsocketpp-dev,
         zlib1g-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development files for C++ REST SDK / Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains header files that are needed to develop and
 compile applications which utilizes the C++ REST SDK / Casablanca framework.

Package: libcpprest-doc
Architecture: all
Section: doc
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Reference manual for C++ REST SDK / Casablanca
 The C++ REST SDK (codename "Casablanca") is a Microsoft project for cloud-based
 client-server communication in native code using a modern asynchronous C++ API
 design. This project allows C++ developers to take advantage of the radical
 shift in software architecture that cloud computing represents.
  * Support for accessing REST services from native code on Linux, Windows
    Vista, Windows 7, and Windows 8 by providing asynchronous C++ bindings
    to HTTP, JSON, and URIs
  * Implementation of Asynchronous Streams and Stream Buffers
  * A consistent and powerful model for composing asynchronous operations based
    on C++ 11 features
  * A set of samples and reference documentation
  * New experimental features such as HTTP Listener library and support for
  Windows Phone 8 and Windows XP.
 .
 This package contains the common documentation.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk
SONAME := $(shell echo $(DEB_VERSION_UPSTREAM) | cut -d "." -f1,2)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	rm -rf html latex

override_dh_auto_configure:
	dh_auto_configure -- -DCPPREST_EXPORT_DIR=cmake/cpprestsdk -DCPPREST_EXCLUDE_BROTLI=OFF -DWERROR=OFF

override_dh_auto_build-indep:
	doxygen Release/public_apis_doxyfile

override_dh_install-indep:
	dh_install -plibcpprest-doc html/* usr/share/doc/libcpprest-doc/html

override_dh_auto_test:
ifeq ($(DEB_HOST_ARCH_ENDIAN),little)
	if [ -f obj-*/Release/Binaries/test_runner ]; then dh_auto_test; fi
endif

## cpprest 2.10.16

=== Release/src/CMakeLists.txt ===
--- 
+++ 
@@ -236,9 +236,9 @@
 endif()
 
 if(CPPREST_INSTALL_HEADERS)
-  install(FILES ${HEADERS_CPPREST} DESTINATION include/cpprest)
-  install(FILES ${HEADERS_PPLX} DESTINATION include/pplx)
-  install(FILES ${HEADERS_DETAILS} DESTINATION include/cpprest/details)
+  install(FILES ${HEADERS_CPPREST} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cpprest)
+  install(FILES ${HEADERS_PPLX} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pplx)
+  install(FILES ${HEADERS_DETAILS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/cpprest/details)
 endif()
 
 if(CPPREST_INSTALL)
@@ -281,9 +281,10 @@
   )
 
   configure_file(../cmake/cpprestsdk-config.in.cmake "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake" @ONLY)
+  configure_file(../cmake/cpprestsdk-config-version.in.cmake "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config-version.cmake" @ONLY)
 
   install(
-    FILES "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake"
+    FILES "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/cpprestsdk-config-version.cmake"
     DESTINATION ${CMAKE_INSTALL_LIBDIR}/${CPPREST_EXPORT_DIR}
   )
   install(

=== debian/changelog ===
cpprest (2.10.16-2) unstable; urgency=medium

  * Disable one more test using internet connection

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 May 2020 22:54:29 +0200

cpprest (2.10.16-1) unstable; urgency=medium

  * New upstream version 2.10.16

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 May 2020 11:46:28 +0200

## cpprest 2.10.17

=== Release/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 set(CMAKE_LEGACY_CYGWIN_WIN32 0)
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
 if(POLICY CMP0042)
   cmake_policy(SET CMP0042 NEW) # use MACOSX_RPATH
 endif()
@@ -11,7 +11,7 @@
 
 set(CPPREST_VERSION_MAJOR 2)
 set(CPPREST_VERSION_MINOR 10)
-set(CPPREST_VERSION_REVISION 15)
+set(CPPREST_VERSION_REVISION 17)
 
 enable_testing()

=== debian/changelog ===
cpprest (2.10.17-2) unstable; urgency=medium

  * Do a build also on arch:all to avoid install failures

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Jan 2021 12:34:20 +0100

cpprest (2.10.17-1) unstable; urgency=medium

  * New upstream version 2.10.17
  * Bump compat level to 13
  * Bump copyright years

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Jan 2021 10:36:33 +0100

## cpprest 2.10.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)
project(cpprestsdk-root NONE)
enable_testing()
add_subdirectory(Release)

=== Build_iOS/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 project(casablanca-ios NONE)
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.9)
 
 enable_testing()

=== Release/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 set(CPPREST_VERSION_MAJOR 2)
 set(CPPREST_VERSION_MINOR 10)
-set(CPPREST_VERSION_REVISION 17)
+set(CPPREST_VERSION_REVISION 18)
 
 enable_testing()

=== Release/tests/CMakeLists.txt ===
set(UnitTestpp_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/common/UnitTestpp)
set(Utilities_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/common/utilities/include)

include_directories (${UnitTestpp_INCLUDE_DIR} ${Utilities_INCLUDE_DIR})

add_subdirectory(common)
add_subdirectory(functional)

=== Release/samples/Oauth1Client/CMakeLists.txt ===
if (NOT WINDOWS_STORE AND NOT WINDOWS_PHONE)
  add_executable(oauth1client
    Oauth1Client.cpp
    )

  target_link_libraries(oauth1client cpprest)
endif()

=== Release/samples/Oauth2Client/CMakeLists.txt ===
if (NOT WINDOWS_STORE AND NOT WINDOWS_PHONE)
  add_executable(oauth2client
    Oauth2Client.cpp
    )

  target_link_libraries(oauth2client cpprest)
endif()

=== Release/samples/BlackJack/BlackJack_Server/CMakeLists.txt ===
if (UNIX)
  add_definitions(-Wno-sign-compare -Wno-enum-compare)
endif()

add_executable(blackjackserver
  BlackJack_Server.cpp
  Dealer.cpp
  Table.cpp
  )

target_link_libraries(blackjackserver cpprest)

configure_pch(blackjackserver stdafx.h stdafx.cpp /Zm120)

=== Release/tests/functional/streams/CMakeLists.txt ===
set(SOURCES
  fstreambuf_tests.cpp
  istream_tests.cpp
  memstream_tests.cpp
  ostream_tests.cpp
  stdstream_tests.cpp
)
if(WINDOWS_STORE OR WINDOWS_PHONE)
  list(APPEND SOURCES winrt_interop_tests.cpp)
else()
  list(APPEND SOURCES fuzz_tests.cpp)
  if(WIN32)
    list(APPEND SOURCES CppSparseFile.cpp)
  endif()
endif()

add_casablanca_test(streams_test SOURCES)
if(NOT WIN32 OR CPPREST_WEBSOCKETS_IMPL STREQUAL "wspp")
  cpprest_find_boost()
  if(NOT TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
    target_link_libraries(streams_test PRIVATE cpprestsdk_boost_internal)
  else()
    target_include_directories(streams_test PRIVATE $<TARGET_PROPERTY:cpprestsdk_boost_internal,INTERFACE_INCLUDE_DIRECTORIES>)
  endif()
endif()

configure_pch(streams_test stdafx.h stdafx.cpp)

=== Release/tests/functional/http/client/CMakeLists.txt ===
set(SOURCES
  authentication_tests.cpp
  building_request_tests.cpp
  client_construction.cpp
  compression_tests.cpp
  connection_pool_tests.cpp
  connections_and_errors.cpp
  header_tests.cpp
  http_client_fuzz_tests.cpp
  http_client_tests.cpp
  http_methods_tests.cpp
  multiple_requests.cpp
  oauth1_tests.cpp
  oauth2_tests.cpp
  outside_tests.cpp
  pipeline_stage_tests.cpp
  progress_handler_tests.cpp
  proxy_tests.cpp
  redirect_tests.cpp
  request_helper_tests.cpp
  request_stream_tests.cpp
  request_uri_tests.cpp
  response_extract_tests.cpp
  response_stream_tests.cpp
  status_code_reason_phrase_tests.cpp
  to_string_tests.cpp
)

add_casablanca_test(httpclient_test SOURCES)
if(TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
  target_include_directories(httpclient_test PRIVATE ../utilities/include)
else()
  target_link_libraries(httpclient_test PRIVATE httptest_utilities)
endif()

configure_pch(httpclient_test stdafx.h stdafx.cpp)

if(NOT WIN32)
  cpprest_find_boost()
  target_link_libraries(httpclient_test PRIVATE cpprestsdk_boost_internal)
endif()

=== Release/tests/functional/http/listener/CMakeLists.txt ===
if(NOT WINDOWS_STORE AND NOT WINDOWS_PHONE)
  set (SOURCES
    building_response_tests.cpp
    connections_and_errors.cpp
    header_tests.cpp
    listener_construction_tests.cpp
    reply_helper_tests.cpp
    request_extract_tests.cpp
    request_handler_tests.cpp
    request_relative_uri_tests.cpp
    request_stream_tests.cpp
    requests_tests.cpp
    response_stream_tests.cpp
    status_code_reason_phrase_tests.cpp
    to_string_tests.cpp
  )

  add_casablanca_test(httplistener_test SOURCES)
  if(TEST_LIBRARY_TARGET_TYPE STREQUAL "OBJECT")
    target_include_directories(httplistener_test PRIVATE ../utilities/include)
  else()
    target_link_libraries(httplistener_test PRIVATE httptest_utilities)
  endif()

  configure_pch(httplistener_test stdafx.h stdafx.cpp)
endif()

=== debian/changelog ===
cpprest (2.10.18-1build2) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 23 Nov 2021 15:24:25 +0100

cpprest (2.10.18-1build1) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 16:55:07 +0000

cpprest (2.10.18-1) unstable; urgency=medium

  * Update watch file for new release
  * New upstream version 2.10.18

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 08 Feb 2021 16:09:24 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: cpprest
 Section: libs
 Priority: optional
-Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Gianfranco Costamagna <locutusofborg@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                libbrotli-dev,
                libboost-atomic-dev,
                libboost-chrono-dev,

=== debian/watch ===
version=4
opts=dversionmangle=s/(\+|\.)dfsg$// \
        https://github.com/Microsoft/cpprestsdk/tags .*/(\d\S*)\.tar\.gz
